//+------------------------------------------------------------------+
//|                                                        herrr.mq5 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <Trade\Trade.mqh>
//--- input parameters
input double      StopLoss=0.1;      // Stop Loss
input double      TakeProfit=0.3;   // Take Profit
input int      ADX_Period=14;     // ADX Period
input int      MALong_Period=60;      // MA_Long
input int      MAShort_Period=20;      // MA_Short
input int      RSI_Period=14;      //RSI Period
input int      Momentum_Period=10;      //Momentum Period
input int      EA_Magic=12345;   // EA Magic Number
input double   RSI_in=60.0;     // RSI_in
input double   RSI_out=40.0;     // RSI_out
input double   Adx_Min=20.0;     // Minimum ADX Value
input double   Momentum_Min=100.0;     // Momentum Value
input double   Lot=100000;          // Lots to Trade
input double   Money=50000; 
//--- Other parameters
string stockList[37] = {"ADVANC","AEONTS","AMATA","AOT","BANPU","BBL","BCH","BDMS","BEAUTY","BTS","CKP","COM7","CPALL","DTAC","ESSO","GPSC","HMPRO","IVL","JMART","KTC","LH","MEGA","MTLS","ORI","PTTEP","RS","SCC","SEAFCO","SF","SPCG","SPRC","TACP","TMB","TRUE","TTW","VGI","WHA"};
int stockCount = 37;



int tradeSize;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {

   
     
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   for(int i=0;i< stockCount;i++)
	{
      string symbol = stockList[i];
      
   PositionSelect(symbol);
   MqlRates rates[];
   datetime tmp;
   
int adxHandle; // handle for our ADX indicator
int malongHandle;  // handle for our Moving Average indicator
int mashortHandle;  // handle for our Moving Average indicator
int rsiHandle;  // handle for our RSI indicator
int momentumHandle;  // handle for our Momentum indicator
int volumeHandle; //hanle for our volume indicator
double plsDI[],minDI[],adxVal[]; // Dynamic arrays to hold the values of +DI, -DI and ADX values for each bars
double mashortVal[]; // Dynamic array to hold the values of Moving Average for each bars
double malongVal[];
double rsiVal[];
double momentumVal[];
double volumeVal[];
double p_close; // Variable to store the close value of a bar
   
   //--- Get handle for ADX indicator
   adxHandle=iADX(symbol,0,ADX_Period);
//--- Get the handle for Long Moving Average indicator
   malongHandle=iMA(symbol,0,MALong_Period,0,MODE_EMA,PRICE_CLOSE);
//--- Get the handle for Short Moving Average indicator
   mashortHandle=iMA(symbol,0,MAShort_Period,0,MODE_EMA,PRICE_CLOSE);   
//--- Get the handle for Moving Average indicator
   rsiHandle=iRSI(symbol,0,RSI_Period,PRICE_CLOSE);   
//--- Get the handle for Momentum indicator
   momentumHandle=iMomentum(symbol,0,Momentum_Period,PRICE_CLOSE);
//--- Get the handle for Volume indicator
   volumeHandle=iVolumes(symbol,0,VOLUME_REAL);  
   
// the ADX DI+values array
   ArraySetAsSeries(plsDI,true);
// the ADX DI-values array
   ArraySetAsSeries(minDI,true);
// the ADX values arrays
   ArraySetAsSeries(adxVal,true);
// the MALonbg values arrays
   ArraySetAsSeries(malongVal,true);
// the MAShort values arrays
   ArraySetAsSeries(mashortVal,true);   
// the RSI values arrays
   ArraySetAsSeries(rsiVal,true);  
// the Momentum values arrays
   ArraySetAsSeries(momentumVal,true);
// the Volume values arrays
   ArraySetAsSeries(volumeVal,true);  
   
   
   ArraySetAsSeries(rates,true);
   int copied=CopyRates(symbol,Period(),0,Bars(symbol,Period()),rates); // Copied all datas
   datetime t1 = rates[1].time;
   
   CopyBuffer(adxHandle,0,0,3,adxVal);
   CopyBuffer(adxHandle,1,0,3,plsDI);
   CopyBuffer(adxHandle,2,0,3,minDI);
   CopyBuffer(malongHandle,0,0,3,malongVal);
   CopyBuffer(mashortHandle,0,0,3,mashortVal);
   CopyBuffer(rsiHandle,0,0,3,rsiVal);
   CopyBuffer(momentumHandle,0,0,3,momentumVal);
   CopyBuffer(volumeHandle,0,0,3,volumeVal);
   
   CTrade cEATrade;
   
   bool Buy_Condition_1=(mashortVal[0]>mashortVal[1]) && (mashortVal[1]>mashortVal[2])&& (mashortVal[0]>malongVal[0]); // MA
   bool Buy_Condition_2 = (rsiVal[0]>RSI_in);         // RSI
   bool Buy_Condition_3 = (adxVal[0]>Adx_Min);          // Current ADX value greater than minimum value (22)
   bool Buy_Condition_4 = (momentumVal[0]>Momentum_Min);         // Momentum
   //bool Buy_Condition_6 = (volumeVal[0]>volumeVal[1]) && (volumeVal[0]>volumeVal[2])&& (volumeVal[0]>volumeVal[3]);  // Volume
   bool Sell_Condition_1 = (rsiVal[0]<RSI_out); // Bull go away
   bool Sell_Condition_2 = (momentumVal[0]<100);  // Bull go away
   bool Sell_Condition_3 = (adxVal[0]<Adx_Min);  // Bull go away
   
   double lev = 1;
   double sl = (1 - StopLoss*lev);
   double tp = (1 + TakeProfit*lev);
   
   //double tradeSize = NormalizeDouble(Money/SymbolInfoDouble(_Symbol,SYMBOL_ASK),0);
   //int tradeSize = 100*round(round(Money/SymbolInfoDouble(_Symbol,SYMBOL_ASK))/100);
   //int checkmod = round(fmod(tradeSize,100));
   //if(checkmod<50) tradeSize = tradeSize-checkmod;
   //else tradeSize = tradeSize-(100-checkmod);
	//if(tradeSize < 100)
   //tradeSize = 100;
   
   if(Sell_Condition_1 && Sell_Condition_2 && Sell_Condition_3 && PositionGetDouble(POSITION_VOLUME)>0)
          {
             cEATrade.PositionOpen(symbol,ORDER_TYPE_SELL,PositionGetDouble(POSITION_VOLUME),SymbolInfoDouble(symbol,SYMBOL_BID),0,0,"");
         
          }
     if(Buy_Condition_1 && Buy_Condition_2&& Buy_Condition_3&& Buy_Condition_4  && PositionGetDouble(POSITION_VOLUME)==0)
          {
            int tradeSize = 100*round(round(fmin(AccountInfoDouble(ACCOUNT_MARGIN_FREE),Money)/SymbolInfoDouble(symbol,SYMBOL_ASK))/100);
            if(tradeSize < 100)
            tradeSize = 100;
            
            cEATrade.PositionOpen(symbol,ORDER_TYPE_BUY,tradeSize,SymbolInfoDouble(symbol,SYMBOL_ASK),SymbolInfoDouble(symbol,SYMBOL_ASK)*sl,SymbolInfoDouble(symbol,SYMBOL_ASK)*tp,"");
            tmp=rates[0].time;
          }
    }
  }
//+------------------------------------------------------------------+
int CountOrder()
{
int ordertotal;
int count=0;
 ordertotal=PositionsTotal()-1;
 for(;ordertotal>=0;ordertotal--)
 {
  PositionSelectByTicket(PositionGetTicket(ordertotal));
  {
   if(Symbol()==PositionGetString(POSITION_SYMBOL)  )
   {
      count++;
    

   }
   
  }
 }
 return(count);
} 